codeforces 815C Karen and Supermarket

C. Karen and Supermarket

time limit per test

2 seconds

memory limit per test

512 megabytes

input

standard input

output

standard output

On the way home, Karen decided to stop by the supermarket to buy some groceries.

She needs to buy a lot of goods, but since she is a student her budget is still quite limited. In fact, she can only spend up to b dollars.

The supermarket sells n goods. The i-th good can be bought for ci dollars. Of course, each good can only be bought once.

Lately, the supermarket has been trying to increase its business. Karen, being a loyal customer, was given n coupons. If Karen purchases the i-th good, she can use the i-th coupon to decrease its price by di. Of course, a coupon cannot be used without buying the corresponding good.

There is, however, a constraint with the coupons. For all i ≥ 2, in order to use the i-th coupon, Karen must also use the xi-th coupon (which may mean using even more coupons to satisfy the requirement for that coupon).

Karen wants to know the following. What is the maximum number of goods she can buy, without exceeding her budget b?

Input

The first line of input contains two integers n and b (1 ≤ n ≤ 5000, 1 ≤ b ≤ 109), the number of goods in the store and the amount of money Karen has, respectively.

The next n lines describe the items. Specifically:

  • The i-th line among these starts with two integers, ci and di (1 ≤ di < ci ≤ 109), the price of the i-th good and the discount when using the coupon for the i-th good, respectively.
  • If i ≥ 2, this is followed by another integer, xi (1 ≤ xi < i), denoting that the xi-th coupon must also be used before this coupon can be used.

Output

Output a single integer on a line by itself, the number of different goods Karen can buy, without exceeding her budget.

Examples

input

Copy

6 16
10 9
10 5 1
12 2 1
20 18 3
10 2 3
2 1 5

output

Copy

4

input

Copy

5 10
3 1
3 1 1
3 1 2
3 1 3
3 1 4

output

Copy

5

Note

In the first test case, Karen can purchase the following 4 items:

  • Use the first coupon to buy the first item for 10 - 9 = 1 dollar.
  • Use the third coupon to buy the third item for 12 - 2 = 10 dollars.
  • Use the fourth coupon to buy the fourth item for 20 - 18 = 2 dollars.
  • Buy the sixth item for 2 dollars.

The total cost of these goods is 15, which falls within her budget. Note, for example, that she cannot use the coupon on the sixth item, because then she should have also used the fifth coupon to buy the fifth item, which she did not do here.

In the second test case, Karen has enough money to use all the coupons and purchase everything.

题意: 现在小明要出去买东西,但是小明只有为数不多的m元,但是现在每种商品都有一个优惠,但是有限制条件,要想获得优惠那么就一定要买一个其他的特定的商品,现在你要解决的就是用m元最多能卖多少商品。

思路: 这个题真的是一个树形dp的好题呀,我们知道每个商品都和其他一个商品有关系,这样我们可以建一棵树,很显然就是树形dp,我们可以设dp[u][j][0,1] 分别表示对于u这颗子树,我们选择j个商品,并且u 这个节点使不使用优惠的最小花费。那么我们可以确定的是,初始化dp[u][0][0]=0; dp[u][1][0]=c[u];  dp[u][1][1]=c[u]-d[u]; 转移方程就是 dp[u][i+j ][0]=dp[u][i][0]+dp[v][j][0];dp[u][i+j][1]=dp[u][i][1]+min( dp[u][j][0],dp[u][j][1] ).神奇的是看似是一个n3的算法,但是仔细分析一下,其实是n2的算法因为我们可以只需要枚举 sz[u],和sz[son] 就可以,并没有必要枚举n。

代码: 

#include<bits/stdc++.h>

using namespace std;
typedef long long ll;
const int N =5e3+5;
const ll inf =1e18+5;

ll dp[N][N][2]; //

int n;
ll m;
int c[N],d[N];
vector< int >ve[N];
int sz[N];

void dfs(int u)
{
    dp[u][0][0]=0;
    dp[u][1][0]=c[u];
    dp[u][1][1]=c[u]-d[u];
    sz[u]=1;

    for(int i=0;i<ve[u].size();i++){
        int v=ve[u][i];
        dfs(v);

        for(int i=sz[u];i>=0;i--)
        {
            for(int j=0;j<=sz[v];j++){
                dp[u][i+j][0]=min(dp[u][i+j][0],dp[u][i][0]+dp[v][j][0]);
                dp[u][i+j][1]=min(dp[u][i+j][1],dp[u][i][1]+min(dp[v][j][0],dp[v][j][1]));
            }
        }
        sz[u]+=sz[v];
    }
}

int main()
{
    int u;
    scanf("%d %lld",&n,&m);
    for(int i=0;i<N;i++){
        for(int j=0;j<N;j++){
            for(int k=0;k<2;k++) dp[i][j][k]=inf;
        }
    }
    scanf("%d %d",&c[1],&d[1]);
    for(int i=2;i<=n;i++)
    {
        scanf("%d %d %d",&c[i],&d[i],&u);
        ve[u].push_back(i);
    }
    dfs(1);

    int maxx=0;
    for(int i=1;i<=n;i++){
        if(min(dp[1][i][0],dp[1][i][1])<=m){
            maxx=max(maxx,i);
        }
    }
    cout<<maxx<<endl;

    return 0;
}

 

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值